<beans xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xmlns="http://www.springframework.org/schema/beans"
       xsi:schemaLocation="http://www.springframework.org/schema/beans http://www.springframework.org/schema/beans/spring-beans.xsd">


    <!--  <import resource="endpoints.xml" />-->

    <!-- MPay routes settings -->
    <!-- ActiveMQ settings -->
    <bean id="jmsConnectionFactoryJFW" class="org.apache.activemq.ActiveMQConnectionFactory">
        <property name="brokerURL" value="${env_broker_url:tcp://localhost:61616}"/>
        <property name="redeliveryPolicy">
            <bean class="org.apache.activemq.RedeliveryPolicy">
                <property name="maximumRedeliveries" value="1"/>
            </bean>
        </property>
    </bean>
    <bean id="pooledJmsConnectionFactoryJFW" class="org.apache.activemq.pool.PooledConnectionFactory"
          init-method="start" destroy-method="stop">
        <property name="maxConnections" value="8"/>
        <property name="connectionFactory" ref="jmsConnectionFactoryJFW"/>
        <!-- set idleTimeout to 0 to fix this problem https://issues.apache.org/jira/browse/AMQ-4366 -->
        <property name="idleTimeout" value="0"/>
    </bean>
    <bean id="jmsTransactionManagerJFW"
          class="org.springframework.jms.connection.JmsTransactionManager">
        <property name="connectionFactory" ref="pooledJmsConnectionFactoryJFW"/>
    </bean>

    <bean id="jfwActivemq" class="org.apache.activemq.camel.component.ActiveMQComponent">
        <property name="connectionFactory" ref="pooledJmsConnectionFactoryJFW"/>
        <property name="transacted" value="true"/>
        <property name="transactionManager" ref="jmsTransactionManagerJFW"/>
        <property name="receiveTimeout" value="250"/>
        <property name="cacheLevelName" value="CACHE_CONSUMER"/>
    </bean>

    <bean id="ActivemqNonTransacted" class="org.apache.activemq.camel.component.ActiveMQComponent">
        <property name="connectionFactory" ref="pooledJmsConnectionFactoryJFW"/>
        <property name="receiveTimeout" value="250"/>
    </bean>

    <bean id="PROPAGATION_REQUIRED_JMS_JFW" class="org.apache.camel.spring.spi.SpringTransactionPolicy">
        <property name="transactionManager" ref="jmsTransactionManagerJFW"/>
        <property name="propagationBehaviorName" value="PROPAGATION_REQUIRED"/>
    </bean>
    <bean id="PROPAGATION_REQUIRES_NEW_JMS_JFW" class="org.apache.camel.spring.spi.SpringTransactionPolicy">
        <property name="transactionManager" ref="jmsTransactionManagerJFW"/>
        <property name="propagationBehaviorName" value="PROPAGATION_REQUIRES_NEW"/>
    </bean>
    <bean id="AutoLoginProcessor" class="com.progressoft.mpay.AutoLoginProcessor"/>
    <bean id="handleMPAYRequest" class="com.progressoft.mpay.HandleMPAYRequest"/>
    <bean id="CreateMPClearWebServiceRequest" class="com.progressoft.mpay.CreateMPClearWebServiceRequest"/>

    <bean id="CreateCXFProcessMessageOperationResponse"
          class="com.progressoft.mpay.CreateCXFProcessMessageOperationResponse"/>
    <bean id="operationContract" class="com.progressoft.mpay.OperationContract"/>
    <bean id="Send1220" class="com.progressoft.mpay.mpclearinteg.Send1220"/>
    <bean id="processFileInstructions" class="com.progressoft.mpay.registration.ProcessFileInstructions"/>
    <bean id="processCorporateFileInstructions"
          class="com.progressoft.mpay.registration.ProcessCorporateFileInstructions"/>
    <bean id="MPayMessageHandler" class="com.progressoft.mpay.messages.MPayMessageHandler"/>
    <bean id="MPClearMessageHandler" class="com.progressoft.mpay.mpclear.MPClearMessageHandler"/>
    <bean id="MPayMessageExceptionHandler" class="com.progressoft.mpay.messages.MPayMessageExceptionHandler"/>
    <bean id="MPClearShortcutMessageHandler" class="com.progressoft.mpay.mpclear.MPClearShortcutMessageHandler"/>

    <bean id="jfwInwardProcessor" class="com.progressoft.mpay.jfwmpclearinteg.processors.JfwInwardProcessor"/>
    <bean id="jfwOutwardPaymentProcessor"
          class="com.progressoft.mpay.jfwmpclearinteg.processors.JfwOutwardPaymentProcessor"/>
    <bean id="jfwOutwardRegistrationProcessor"
          class="com.progressoft.mpay.jfwmpclearinteg.processors.JfwOutwardRegistrationProcessor"/>


    <bean id="jmsConnectionFactoryMPCJFW" class="org.apache.activemq.ActiveMQConnectionFactory">
        <property name="brokerURL" value="${env_broker_url:tcp://192.168.1.153:61999}"/>
        <property name="redeliveryPolicy">
            <bean class="org.apache.activemq.RedeliveryPolicy">
                <property name="maximumRedeliveries" value="1"/>
            </bean>
        </property>
    </bean>

    <bean id="pooledJmsConnectionFactoryMPCJFW" class="org.apache.activemq.pool.PooledConnectionFactory"
          init-method="start" destroy-method="stop">
        <property name="maxConnections" value="8"/>
        <property name="connectionFactory" ref="jmsConnectionFactoryMPCJFW"/>
        <!-- set idleTimeout to 0 to fix this problem https://issues.apache.org/jira/browse/AMQ-4366 -->
        <property name="idleTimeout" value="0"/>
    </bean>
    <bean id="jmsTransactionManagerMPCJFW"
          class="org.springframework.jms.connection.JmsTransactionManager">
        <property name="connectionFactory" ref="pooledJmsConnectionFactoryMPCJFW"/>
    </bean>

    <bean id="jfwMPCActivemq" class="org.apache.activemq.camel.component.ActiveMQComponent">
        <property name="connectionFactory" ref="pooledJmsConnectionFactoryMPCJFW"/>
        <property name="transacted" value="true"/>
        <property name="transactionManager" ref="jmsTransactionManagerMPCJFW"/>
        <property name="receiveTimeout" value="250"/>
        <property name="cacheLevelName" value="CACHE_CONSUMER"/>
    </bean>
</beans>